--Limpiando la Cache
DBCC FREEPROCCACHE;
GO

-- Ejecutando la consulta (No seleccionar el comentario en la primera prueba y si en la segunda prueba)
SELECT AVG(ListPrice) FROM Production.Product
GO 5


--Verificando los planes de Ejecucion almacenados en la Cache
SELECT qp.query_plan, 
       CP.usecounts, 
       cp.cacheobjtype, 
       cp.size_in_bytes, 
       cp.usecounts, 
       SQLText.text
  FROM sys.dm_exec_cached_plans AS CP
  CROSS APPLY sys.dm_exec_sql_text( plan_handle)AS SQLText
  CROSS APPLY sys.dm_exec_query_plan( plan_handle)AS QP
  WHERE objtype = 'Adhoc' and cp.cacheobjtype = 'Compiled Plan'
  AND SQLText.text LIKE '%Production.Product%'  OPTION(RECOMPILE)


SELECT plan_handle,usecounts, cacheobjtype, objtype, size_in_bytes, text, query_plan
FROM sys.dm_exec_cached_plans 
CROSS APPLY sys.dm_exec_sql_text(plan_handle) 
CROSS APPLY sys.dm_exec_query_plan(plan_handle)
 WHERE objtype = 'Adhoc' and cacheobjtype = 'Compiled Plan'
 AND text LIKE '%Production.Product%'  OPTION(RECOMPILE)